/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.ingreso;

import danielcortes.xyz.data.ConnectionHolder;
import danielcortes.xyz.data.DAOManager;
import danielcortes.xyz.data.SQLiteConnectionHolder;
import danielcortes.xyz.models.caja.Caja;
import danielcortes.xyz.models.caja.CajaDAO;
import danielcortes.xyz.models.tipo_ingreso.TipoIngreso;
import danielcortes.xyz.models.tipo_ingreso.TipoIngresoDAO;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.time.LocalDate;
import java.time.YearMonth;
import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class SQLiteIngresoDAO implements IngresoDAO {

  private static final Logger log = LogManager.getLogger(SQLiteIngresoDAO.class);
  private ConnectionHolder connectionHolder;

  public SQLiteIngresoDAO() {
    this.connectionHolder = new SQLiteConnectionHolder();
  }

  public SQLiteIngresoDAO(ConnectionHolder connectionHolder) {
    this.connectionHolder = connectionHolder;
  }

  @Override
  public List<Ingreso> getAll() {
    log.debug("Se intententaran conseguir todos los Ingreso");
    List<Ingreso> ingresosList = new ArrayList<>();
    String query = "select * from ingresos";

    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        try (ResultSet rs = ps.executeQuery()) {
          TipoIngresoDAO tipoIngresoDAO = DAOManager.getTipoIngresoDAO();
          CajaDAO cajaDAO = DAOManager.getCajaDAO();

          while (rs.next()) {
            //Confio en que la base de datos me dara un id existente
            @SuppressWarnings("OptionalGetWithoutIsPresent")
            TipoIngreso tipoIngreso = tipoIngresoDAO.getById(rs.getInt("tipo_ingreso_id")).get();
            //Confio en que la base de datos me dara un id existente
            @SuppressWarnings("OptionalGetWithoutIsPresent")
            Caja caja = cajaDAO.getById(rs.getInt("caja_id")).get();

            Ingreso ingreso = new Ingreso();

            ingreso.setId(rs.getInt("id"));
            ingreso.setValor(rs.getInt("valor"));
            ingreso.setNroZInicial(rs.getString("nro_z_inicial"));
            ingreso.setNroZFinal(rs.getString("nro_z_final"));
            ingreso.setNroInicial(rs.getString("nro_inicial"));
            ingreso.setNroFinal(rs.getString("nro_final"));
            ingreso.setTipoIngreso(tipoIngreso);
            ingreso.setCaja(caja);

            ingresosList.add(ingreso);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir todos los Egreso", e);
    }

    log.debug("Se consiguieron " + ingresosList.size() + " Ingreso");
    return ingresosList;
  }

  @Override
  public List<Ingreso> getByCaja(Caja caja) {
    log.debug("Se intentara buscar los ingresos de la caja " + caja);
    List<Ingreso> ingresosList = new ArrayList<>();
    if (Caja.EMPTY == caja) {
      log.debug("La Caja era Caja.EMPTY");
      return ingresosList;
    }

    String query = "select * from ingresos where caja_id = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, caja.getId());
        try (ResultSet rs = ps.executeQuery()) {
          TipoIngresoDAO tipoIngresoDAO = DAOManager.getTipoIngresoDAO();
          while (rs.next()) {
            //Confio en que la base de datos me dara un id existente
            @SuppressWarnings("OptionalGetWithoutIsPresent")
            TipoIngreso tipoIngreso = tipoIngresoDAO.getById(rs.getInt("tipo_ingreso_id")).get();

            Ingreso ingreso = new Ingreso();

            ingreso.setId(rs.getInt("id"));
            ingreso.setValor(rs.getInt("valor"));
            ingreso.setNroZInicial(rs.getString("nro_z_inicial"));
            ingreso.setNroZFinal(rs.getString("nro_z_final"));
            ingreso.setNroInicial(rs.getString("nro_inicial"));
            ingreso.setNroFinal(rs.getString("nro_final"));
            ingreso.setTipoIngreso(tipoIngreso);
            ingreso.setCaja(caja);

            ingresosList.add(ingreso);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar buscar los Ingreso de la caja " + caja, e);
    }
    log.debug("Se consiguieron " + ingresosList.size() + " Ingreso");
    return ingresosList;
  }

  @Override
  public Optional<Ingreso> getById(int id) {
    log.debug("Se intentara conseguir un Ingreso con id " + id);
    Ingreso ingreso = null;
    String query = "select * from ingresos where id = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, id);
        try (ResultSet rs = ps.executeQuery()) {
          TipoIngresoDAO tipoIngresoDAO = DAOManager.getTipoIngresoDAO();
          CajaDAO cajaDAO = DAOManager.getCajaDAO();

          if (rs.next()) {
            //Confio en que la base de datos me dara un id existente
            @SuppressWarnings("OptionalGetWithoutIsPresent")
            TipoIngreso tipoIngreso = tipoIngresoDAO.getById(rs.getInt("tipo_ingreso_id")).get();

            //Confio en que la base de datos me dara un id existente
            @SuppressWarnings("OptionalGetWithoutIsPresent")
            Caja caja = cajaDAO.getById(rs.getInt("caja_id")).get();

            ingreso = new Ingreso();

            ingreso.setId(rs.getInt("id"));
            ingreso.setValor(rs.getInt("valor"));
            ingreso.setNroZInicial(rs.getString("nro_z_inicial"));
            ingreso.setNroZFinal(rs.getString("nro_z_final"));
            ingreso.setNroInicial(rs.getString("nro_inicial"));
            ingreso.setNroFinal(rs.getString("nro_final"));
            ingreso.setTipoIngreso(tipoIngreso);
            ingreso.setCaja(caja);
          }
        }
      }
    } catch (
        SQLException e) {
      log.error("Error al intentar conseguir un Ingreso con el id " + id);
    }
    log.debug("Se consiguio el Ingreso " + ingreso);
    return Optional.ofNullable(ingreso);
  }

  @Override
  public List<Ingreso> getByTipoIngreso(TipoIngreso tipoIngreso) {
    log.debug("Se intentara conseguir los Ingreso con TipoIngreso" + tipoIngreso);
    List<Ingreso> ingresosList = new ArrayList<>();
    String query = "select ingresos.* from ingresos inner join tipos_ingreso on (ingresos.tipo_ingreso_id = tipos_ingreso.id) where ingresos.tipo_ingreso_id = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, tipoIngreso.getId());
        try (ResultSet rs = ps.executeQuery()) {
          CajaDAO cajaDAO = DAOManager.getCajaDAO();

          while (rs.next()) {
            //Confio en que la base de datos me dara un id existente
            @SuppressWarnings("OptionalGetWithoutIsPresent")
            Caja caja = cajaDAO.getById(rs.getInt("caja_id")).get();

            Ingreso ingreso = new Ingreso();

            ingreso.setId(rs.getInt("id"));
            ingreso.setValor(rs.getInt("valor"));
            ingreso.setNroZInicial(rs.getString("nro_z_inicial"));
            ingreso.setNroZFinal(rs.getString("nro_z_final"));
            ingreso.setNroInicial(rs.getString("nro_inicial"));
            ingreso.setNroFinal(rs.getString("nro_final"));
            ingreso.setTipoIngreso(tipoIngreso);
            ingreso.setCaja(caja);

            ingresosList.add(ingreso);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir los Ingreso con tipoIngreso " + tipoIngreso);
    }
    log.debug("Se consiguieron " + ingresosList.size() + " Ingresos");
    return ingresosList;
  }

  @Override
  public int getTotalIngreso(Caja caja) {
    log.debug("Se intentara conseguir el total de ingreso en la caja " + caja);
    int total = 0;
    if (Caja.EMPTY == caja) {
      log.debug("La caja era Caja.EMPTY");
      return total;
    }

    String query = "select sum(valor) from ingresos where caja_id = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, caja.getId());
        try (ResultSet rs = ps.executeQuery()) {
          if (rs.next()) {
            total = rs.getInt(1);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir el total de ingreso en la caja " + caja);
    }
    log.debug("Se el total de ingreso es " + total);
    return total;
  }

  @Override
  public int getTotalIngresoMes(YearMonth mes) {
    log.debug("Se intentara conseguir la suma de los ingreso en el mes " + mes);
    int total = 0;
    String query =
        "select sum(valor) from ingresos inner join caja on (ingresos.caja_id == caja.id) where caja.fecha between ? and ? and ingresos.tipo_ingreso_id != 5";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        LocalDate start = mes.atDay(1);
        LocalDate end = mes.atEndOfMonth();
        ps.setString(1, start.toString());
        ps.setString(2, end.toString());

        try (ResultSet rs = ps.executeQuery()) {
          if (rs.next()) {
            total = rs.getInt(1);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir la suma de los ingresos en el mes " + mes);
    }
    log.debug("La suma de los ingresos es " + total);
    return total;
  }

  @Override
  public int getTotalExentasMes(YearMonth mes) {
    log.debug("Se intentara conseguir el total de boletas exentas en el mes " + mes);
    int total = 0;
    String query =
        "select sum(valor) from ingresos inner join caja on (ingresos.caja_id == caja.id) where caja.fecha between ? and ? and ingresos.tipo_ingreso_id = 5";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        LocalDate start = mes.atDay(1);
        LocalDate end = mes.atEndOfMonth();
        ps.setString(1, start.toString());
        ps.setString(2, end.toString());
        try (ResultSet rs = ps.executeQuery()) {
          if (rs.next()) {
            total = rs.getInt(1);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir el total de boletas exentas en el mes " + mes);
    }
    log.debug("El total conseguido es " + total);
    return total;
  }

  @Override
  public int getTotalIngresoEnCajaPorTipo(Caja caja, TipoIngreso tipoIngreso) {
    log.debug("Se intentara obtener el total de ingresos de la caja " + caja + " y el tipo "
        + tipoIngreso);
    int total = 0;
    if (caja == Caja.EMPTY) {
      return total;
    }
    String query = "select sum(valor) from ingresos where caja_id = ? and tipo_ingreso_id = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, caja.getId());
        ps.setInt(2, tipoIngreso.getId());
        try (ResultSet rs = ps.executeQuery()) {
          if (rs.next()) {
            total = rs.getInt(1);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar obtener el total de ingresos de la caja " + caja + " y el tipo "
          + tipoIngreso);
    }
    log.debug("Se obtuvo el total " + total);
    return total;
  }

  @Override
  public Optional<String> getPrimerNroInicialDeCajaDeTipo(Caja caja, TipoIngreso tipoIngreso) {
    log.debug("Se intentara conseguir el primer numero inicial de ingreso en la caja " + caja
        + " de tipo " + tipoIngreso);
    String nroInicial = null;

    if (caja == Caja.EMPTY) {
      log.debug("La caja era Caja.EMPY");
      return Optional.ofNullable(nroInicial);
    }

    String query = "select nro_inicial from ingresos where caja_id = ? and tipo_ingreso_id = ? order by nro_inicial asc limit 1";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, caja.getId());
        ps.setInt(2, tipoIngreso.getId());
        try (ResultSet rs = ps.executeQuery()) {
          if (rs.next()) {
            nroInicial = rs.getString(1);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir el primer numero inicial de ingreso en la caja " + caja
          + " de tipo " + tipoIngreso);
    }
    log.debug("Se consiguio el primero numero inicial " + nroInicial);
    return Optional.ofNullable(nroInicial);
  }

  @Override
  public Optional<String> getUltimoNroFinalDeCajaDeTipo(Caja caja, TipoIngreso tipoIngreso) {
    log.debug(
        "Se intentara conseguir el ultimo numero final de ingreso en la caja " + caja + " de tipo "
            + tipoIngreso);
    String nroFinal = null;
    if (caja == Caja.EMPTY) {
      log.debug("La caja era Caja.EMPY");
      return Optional.ofNullable(nroFinal);
    }

    String query = "select nro_final from ingresos where caja_id = ? and tipo_ingreso_id = ? order by nro_inicial desc limit 1";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, caja.getId());
        ps.setInt(2, tipoIngreso.getId());
        try (ResultSet rs = ps.executeQuery()) {
          if (rs.next()) {
            nroFinal = rs.getString(1);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir el ultimo numero final de ingreso en la caja " + caja
          + " de tipo " + tipoIngreso);
    }
    log.debug("Se consiguio el ultimo numero final " + nroFinal);
    return Optional.ofNullable(nroFinal);
  }

  @Override
  public Optional<String> getPrimerNroZInicialDeCaja(Caja caja) {
    log.debug("Se intentara conseguir el primero numero z inicial dentro de la caja " + caja);
    String nroZInicial = null;

    if (caja == Caja.EMPTY) {
      log.debug("La caja era Caja.EMPTY");
      return Optional.ofNullable(nroZInicial);
    }

    String query = "select nro_z_inicial from ingresos where caja_id = ? and tipo_ingreso_id = 1 order by nro_inicial desc limit 1";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, caja.getId());
        try (ResultSet rs = ps.executeQuery()) {
          if (rs.next()) {
            nroZInicial = rs.getString(1);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir el primer numero z inicial dentro de la caja " + caja);
    }
    log.debug("Se consiguio el primer numero z inicial " + nroZInicial);
    return Optional.ofNullable(nroZInicial);
  }

  @Override
  public Optional<String> getUltimoNroZFinalDeCaja(Caja caja) {
    log.debug("Se intentara conseguir el ultimo numero z final dentro de la caja " + caja);
    String nroZFinal = null;
    if (caja == Caja.EMPTY) {
      log.debug("La caja era Caja.EMPTY");
      return Optional.ofNullable(nroZFinal);
    }
    String query = "select nro_z_final from ingresos where caja_id = ? and tipo_ingreso_id = 1 order by nro_inicial desc limit 1";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, caja.getId());
        try (ResultSet rs = ps.executeQuery()) {
          if (rs.next()) {
            nroZFinal = rs.getString(1);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir el ultimo numero z final dentro de la caja " + caja, e);
    }
    log.debug("Se consiguio el ultimo numero z final " + nroZFinal);
    return Optional.ofNullable(nroZFinal);
  }

  @Override
  public void insert(Ingreso ingreso) {
    log.debug("Se intentara insertar el ingreso " + ingreso);
    String query = "insert into ingresos (valor, nro_z_inicial, nro_z_final, nro_inicial, nro_final, tipo_ingreso_id, caja_id) values (?,?,?,?,?,?,?)";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, ingreso.getValor());
        ps.setString(2, ingreso.getNroZInicial());
        ps.setString(3, ingreso.getNroZFinal());
        ps.setString(4, ingreso.getNroInicial());
        ps.setString(5, ingreso.getNroFinal());
        ps.setInt(6, ingreso.getTipoIngreso().getId());
        ps.setInt(7, ingreso.getCaja().getId());
        ps.executeUpdate();
      }

      try (PreparedStatement ps = conn.prepareStatement("select last_insert_rowid()")) {
        try (ResultSet rs = ps.executeQuery()) {
          rs.next();
          ingreso.setId(rs.getInt(1));
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar insertar el ingreso " + ingreso, e);
    }
    log.debug("Se inserto el ingreso " + ingreso);
  }

  @Override
  public void update(Ingreso ingreso) {
    log.debug("Se intentara actualizar el ingreso " + ingreso);
    String query = "update ingresos set valor = ?, nro_z_inicial = ?, nro_z_final = ?, nro_inicial = ?, nro_final = ?, tipo_ingreso_id = ?, caja_id = ? where id = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, ingreso.getValor());
        ps.setString(2, ingreso.getNroZInicial());
        ps.setString(3, ingreso.getNroZFinal());
        ps.setString(4, ingreso.getNroInicial());
        ps.setString(5, ingreso.getNroFinal());
        ps.setInt(6, ingreso.getTipoIngreso().getId());
        ps.setInt(7, ingreso.getCaja().getId());
        ps.setInt(8, ingreso.getId());
        ps.executeUpdate();
      }
    } catch (SQLException e) {
      log.error("Error al intentar actualizar el ingreso " + ingreso, e);
    }
    log.debug("Se actualizo el ingreso " + ingreso);
  }

  @Override
  public void delete(Ingreso ingreso) {
    log.debug("Se intentara eliminar el ingreso " + ingreso);
    String query = "delete from ingresos where id = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, ingreso.getId());
        ps.executeUpdate();
      }
    } catch (SQLException e) {
      log.error("Error al intentar eliminar el ingreso " + ingreso,  e);
    }
    log.debug("Se elimino el ingreso " + ingreso);
  }
}
